Index: code/trunk/src/core/input/KeyBinder.cc
===================================================================
--- code/trunk/src/core/input/KeyBinder.cc	(revision 5693)
+++ code/trunk/src/core/input/KeyBinder.cc	(revision 5695)
@@ -55,7 +55,4 @@
         mousePosition_[0] = 0;
         mousePosition_[1] = 0;
-
-        joyStickButtons_.reserve(1000);
-        joyStickAxes_.reserve(1000);
 
         RegisterRootObject(KeyBinder);
@@ -167,7 +164,7 @@
             {
                 for (unsigned int i = 0; i < JoyStickButtonCode::numberOfButtons; ++i)
-                    joyStickButtons_[iDev][i].readConfigValue(this->configFile_);
+                    (*joyStickButtons_[iDev])[i].readConfigValue(this->configFile_);
                 for (unsigned int i = 0; i < JoyStickAxisCode::numberOfAxes * 2; ++i)
-                    joyStickAxes_[iDev][i].readConfigValue(this->configFile_);
+                    (*joyStickAxes_[iDev])[i].readConfigValue(this->configFile_);
             }
         }
@@ -179,4 +176,9 @@
     void KeyBinder::initialiseJoyStickBindings()
     {
+        while (joyStickAxes_.size() < joySticks_.size())
+            joyStickAxes_.push_back(shared_ptr<JoyStickAxisVector>(new JoyStickAxisVector()));
+        while (joyStickButtons_.size() < joySticks_.size())
+            joyStickButtons_.push_back(shared_ptr<JoyStickButtonVector>(new JoyStickButtonVector()));
+        // For the case the new size is smaller
         this->joyStickAxes_.resize(joySticks_.size());
         this->joyStickButtons_.resize(joySticks_.size());
@@ -189,18 +191,18 @@
             for (unsigned int i = 0; i < JoyStickButtonCode::numberOfButtons; i++)
             {
-                joyStickButtons_[iDev][i].name_ = JoyStickButtonCode::ByString[i];
-                joyStickButtons_[iDev][i].paramCommandBuffer_ = &paramCommandBuffer_;
-                joyStickButtons_[iDev][i].groupName_ = "JoyStickButtons_" + deviceName;
+                (*joyStickButtons_[iDev])[i].name_ = JoyStickButtonCode::ByString[i];
+                (*joyStickButtons_[iDev])[i].paramCommandBuffer_ = &paramCommandBuffer_;
+                (*joyStickButtons_[iDev])[i].groupName_ = "JoyStickButtons_" + deviceName;
             }
             // joy stick axes
             for (unsigned int i = 0; i < JoyStickAxisCode::numberOfAxes * 2; i++)
             {
-                joyStickAxes_[iDev][i].name_ = JoyStickAxisCode::ByString[i / 2];
+                (*joyStickAxes_[iDev])[i].name_ = JoyStickAxisCode::ByString[i / 2];
                 if (i & 1)
-                    joyStickAxes_[iDev][i].name_ += "Pos";
+                    (*joyStickAxes_[iDev])[i].name_ += "Pos";
                 else
-                    joyStickAxes_[iDev][i].name_ += "Neg";
-                joyStickAxes_[iDev][i].paramCommandBuffer_ = &paramCommandBuffer_;
-                joyStickAxes_[iDev][i].groupName_ = "JoyStickAxes_" + deviceName;
+                    (*joyStickAxes_[iDev])[i].name_ += "Neg";
+                (*joyStickAxes_[iDev])[i].paramCommandBuffer_ = &paramCommandBuffer_;
+                (*joyStickAxes_[iDev])[i].groupName_ = "JoyStickAxes_" + deviceName;
             }
         }
@@ -226,9 +228,9 @@
         {
             for (unsigned int i = 0; i < JoyStickButtonCode::numberOfButtons; i++)
-                allButtons_[joyStickButtons_[iDev][i].groupName_ + "." + joyStickButtons_[iDev][i].name_] = &(joyStickButtons_[iDev][i]);
+                allButtons_[(*joyStickButtons_[iDev])[i].groupName_ + "." + (*joyStickButtons_[iDev])[i].name_] = &((*joyStickButtons_[iDev])[i]);
             for (unsigned int i = 0; i < JoyStickAxisCode::numberOfAxes * 2; i++)
             {
-                allButtons_[joyStickAxes_[iDev][i].groupName_ + "." + joyStickAxes_[iDev][i].name_] = &(joyStickAxes_[iDev][i]);
-                allHalfAxes_.push_back(&(joyStickAxes_[iDev][i]));
+                allButtons_[(*joyStickAxes_[iDev])[i].groupName_ + "." + (*joyStickAxes_[iDev])[i].name_] = &((*joyStickAxes_[iDev])[i]);
+                allHalfAxes_.push_back(&((*joyStickAxes_[iDev])[i]));
             }
         }
@@ -303,6 +305,6 @@
             for (unsigned int i = 0; i < JoyStickAxisCode::numberOfAxes * 2; i++)
             {
-                joyStickAxes_[iDev][i].absVal_ = 0.0f;
-                joyStickAxes_[iDev][i].relVal_ = 0.0f;
+                (*joyStickAxes_[iDev])[i].absVal_ = 0.0f;
+                (*joyStickAxes_[iDev])[i].relVal_ = 0.0f;
             }
         }
@@ -366,5 +368,5 @@
         for (unsigned int i = 0; i < JoyStickAxisCode::numberOfAxes * 2; i++)
         {
-            tickHalfAxis(joyStickAxes_[joyStick][i]);
+            tickHalfAxis((*joyStickAxes_[joyStick])[i]);
         }
     }
@@ -481,5 +483,5 @@
     {
         int i = axisID * 2;
-        JoyStickAxisVector& axis = joyStickAxes_[device];
+        JoyStickAxisVector& axis = *joyStickAxes_[device];
         if (value < 0)
         {
Index: code/trunk/src/core/input/KeyBinder.h
===================================================================
--- code/trunk/src/core/input/KeyBinder.h	(revision 5693)
+++ code/trunk/src/core/input/KeyBinder.h	(revision 5695)
@@ -41,4 +41,5 @@
 #include <string>
 #include <vector>
+#include <boost/shared_ptr.hpp>
 
 #include "InputHandler.h"
@@ -115,5 +116,5 @@
         };
         //! Actual key bindings for joy stick buttons
-        std::vector<JoyStickButtonVector> joyStickButtons_;
+        std::vector<shared_ptr<JoyStickButtonVector> > joyStickButtons_;
         //! Helper class to use something like std:vector<HalfAxis[48]>
         struct JoyStickAxisVector
@@ -123,5 +124,5 @@
         };
         //! Actual key bindings for joy stick axes (and sliders)
-        std::vector<JoyStickAxisVector> joyStickAxes_;
+        std::vector<shared_ptr<JoyStickAxisVector> > joyStickAxes_;
 
         //! Pointer map with all Buttons, including half axes
@@ -191,11 +192,11 @@
 
     inline void KeyBinder::buttonPressed (unsigned int device, JoyStickButtonCode::ByEnum button)
-    { joyStickButtons_[device][button].execute(KeybindMode::OnPress); }
+    { (*joyStickButtons_[device])[button].execute(KeybindMode::OnPress); }
 
     inline void KeyBinder::buttonReleased(unsigned int device, JoyStickButtonCode::ByEnum button)
-    { joyStickButtons_[device][button].execute(KeybindMode::OnRelease); }
+    { (*joyStickButtons_[device])[button].execute(KeybindMode::OnRelease); }
 
     inline void KeyBinder::buttonHeld    (unsigned int device, JoyStickButtonCode::ByEnum button)
-    { joyStickButtons_[device][button].execute(KeybindMode::OnHold); }
+    { (*joyStickButtons_[device])[button].execute(KeybindMode::OnHold); }
 
     inline void KeyBinder::allDevicesUpdated(float dt)
Index: code/trunk/src/core/input/KeyDetector.cc
===================================================================
--- code/trunk/src/core/input/KeyDetector.cc	(revision 5693)
+++ code/trunk/src/core/input/KeyDetector.cc	(revision 5695)
@@ -70,5 +70,6 @@
     {
         KeyBinder::JoyStickQuantityChanged(joyStickList);
-        setCallbackCommand(callbackCommand_);
+        if (!callbackCommand_.empty())
+            setCallbackCommand(callbackCommand_);
     }
 }
Index: code/trunk/src/network/CMakeLists.txt
===================================================================
--- code/trunk/src/network/CMakeLists.txt	(revision 5693)
+++ code/trunk/src/network/CMakeLists.txt	(revision 5695)
@@ -35,9 +35,29 @@
   TrafficControl.cc
 )
+
+SET_SOURCE_FILES(NETWORK_HDR_FILES
+  ChatListener.h
+  Client.h
+  ClientConnection.h
+  ClientConnectionListener.h
+  ClientInformation.h
+  Connection.h
+  FunctionCallManager.h
+  GamestateClient.h
+  GamestateHandler.h
+  GamestateManager.h
+  Host.h
+  NetworkFunction.h
+  NetworkPrecompiledHeaders.h
+  NetworkPrereqs.h
+  Server.h
+  ServerConnection.h
+  TrafficControl.h
+)
+
 ADD_SUBDIRECTORY(packet)
 ADD_SUBDIRECTORY(synchronisable)
 
 ORXONOX_ADD_LIBRARY(network
-  FIND_HEADER_FILES
   DEFINE_SYMBOL
     "NETWORK_SHARED_BUILD"
@@ -51,4 +71,4 @@
     core
   SOURCE_FILES
-    ${NETWORK_SRC_FILES}
+    ${NETWORK_SRC_FILES} ${NETWORK_HDR_FILES}
 )
Index: code/trunk/src/network/ClientInformation.h
===================================================================
--- code/trunk/src/network/ClientInformation.h	(revision 5693)
+++ code/trunk/src/network/ClientInformation.h	(revision 5695)
@@ -49,5 +49,5 @@
 
   /**
-  * This class implements a list for client informations
+  * This class implements a list for client information
   * @author Oliver Scheuss
   */
Index: code/trunk/src/network/packet/CMakeLists.txt
===================================================================
--- code/trunk/src/network/packet/CMakeLists.txt	(revision 5693)
+++ code/trunk/src/network/packet/CMakeLists.txt	(revision 5695)
@@ -1,4 +1,3 @@
 ADD_SOURCE_FILES(NETWORK_SRC_FILES
-  Packet.cc
   Acknowledgement.cc
   Chat.cc
@@ -8,4 +7,18 @@
   FunctionCalls.cc
   Gamestate.cc
+  Packet.cc
   Welcome.cc
 )
+
+ADD_SOURCE_FILES(NETWORK_HDR_FILES
+  Acknowledgement.h
+  Chat.cc
+  Chat.h
+  ClassID.h
+  DeleteObjects.h
+  FunctionCalls.h
+  FunctionIDs.h
+  Gamestate.h
+  Packet.h
+  Welcome.h
+)
Index: code/trunk/src/network/synchronisable/CMakeLists.txt
===================================================================
--- code/trunk/src/network/synchronisable/CMakeLists.txt	(revision 5693)
+++ code/trunk/src/network/synchronisable/CMakeLists.txt	(revision 5695)
@@ -5,2 +5,9 @@
   SynchronisableVariable.cc
 )
+
+ADD_SOURCE_FILES(NETWORK_HDR_FILES
+  NetworkCallback.h
+  NetworkCallbackManager.h
+  Synchronisable.h
+  SynchronisableVariable.h
+)
Index: code/trunk/src/ois/OISEffect.cpp
===================================================================
--- code/trunk/src/ois/OISEffect.cpp	(revision 5693)
+++ code/trunk/src/ois/OISEffect.cpp	(revision 5695)
@@ -29,4 +29,39 @@
 //Perhaps a case of a crazy extreme optimizer :/ (moved to header)
 //const unsigned int Effect::OIS_INFINITE = 0xFFFFFFFF;
+
+//------------------------------------------------------------------------------//
+static const char* pszEForceString[] = 
+  { "UnknownForce",
+    "ConstantForce", 
+    "RampForce", 
+    "PeriodicForce", 
+    "ConditionalForce", 
+    "CustomForce" };
+
+const char* Effect::getForceTypeName(Effect::EForce eValue)
+{
+  return (eValue >= 0 && eValue < _ForcesNumber) ? pszEForceString[eValue] : "<Bad force type>";
+}
+
+static const char* pszETypeString[] = 
+  { "Unknown",
+    "Constant",
+    "Ramp",
+    "Square", "Triangle", "Sine", "SawToothUp", "SawToothDown",
+    "Friction", "Damper", "Inertia", "Spring",
+    "Custom" };
+
+const char* Effect::getEffectTypeName(Effect::EType eValue)
+{
+  return (eValue >= 0 && eValue < _TypesNumber) ? pszETypeString[eValue] : "<Bad effect type>";
+}
+
+static const char* pszEDirectionString[] = 
+  { "NorthWest", "North", "NorthEast", "East", "SouthEast", "South", "SouthWest", "West"};
+
+const char* Effect::getDirectionName(Effect::EDirection eValue)
+{
+  return (eValue >= 0 && eValue < _DirectionsNumber) ? pszEDirectionString[eValue] : "<Bad direction>";
+}
 
 //------------------------------------------------------------------------------//
Index: code/trunk/src/ois/OISEffect.h
===================================================================
--- code/trunk/src/ois/OISEffect.h	(revision 5693)
+++ code/trunk/src/ois/OISEffect.h	(revision 5695)
@@ -60,6 +60,9 @@
 			PeriodicForce,
 			ConditionalForce,
-			CustomForce
+			CustomForce,
+			_ForcesNumber // Always keep in last position.
 		};
+
+		static const char* getForceTypeName(EForce eValue);
 
 		//! Type of effect
@@ -79,6 +82,9 @@
 			Inertia,     //ConditionalForce
 			Spring,      //ConditionalForce
-			Custom       //CustomForce
+			Custom,      //CustomForce
+			_TypesNumber // Always keep in last position.
 		};
+
+		static const char* getEffectTypeName(EType eValue);
 
 		//! Direction of the Force
@@ -92,6 +98,9 @@
 			South,
 			SouthWest,
-			West
+			West,
+			_DirectionsNumber // Always keep in last position.
 		};
+
+		static const char* getDirectionName(EDirection eValue);
 
 		/**
@@ -168,5 +177,5 @@
 		An optional envelope to be applied to the start/end of an effect. If any of
 		these values are nonzero, then the envelope will be used in setting up the
-		effect. Not currently utilised.. But, will be soon.
+		effect.
 	*/
 	class _OISExport Envelope : public ForceEffect
@@ -178,12 +187,21 @@
   #pragma warning (disable : 4800)
 #endif
-		bool isUsed() { return attackLength | attackLevel | fadeLength | fadeLevel; }
+		bool isUsed() const { return attackLength | attackLevel | fadeLength | fadeLevel; }
 #if defined(OIS_MSVC_COMPILER)
   #pragma warning (pop)
 #endif
 
-		unsigned short attackLength;
+		// Duration of the attack (microseconds)
+		unsigned int attackLength;
+
+		// Absolute level at the beginning of the attack (0 to 10K)
+		// (automatically signed when necessary by FF core according to effect level sign)
 		unsigned short attackLevel;
-		unsigned short fadeLength;
+
+		// Duration of fade (microseconds)
+		unsigned int fadeLength;
+
+		// Absolute level at the end of fade (0 to 10K)
+		// (automatically signed when necessary by FF core according to effect level sign)
 		unsigned short fadeLevel;
 	};
@@ -211,5 +229,5 @@
 		RampEffect() : startLevel(0), endLevel(0) {}
 
-        class Envelope envelope; //Optional envolope
+        class Envelope envelope; //Optional envelope
 		signed short startLevel;  //-10K to +10k
 		signed short endLevel;    //-10K to +10k
Index: code/trunk/src/ois/OISForceFeedback.cpp
===================================================================
--- code/trunk/src/ois/OISForceFeedback.cpp	(revision 5693)
+++ code/trunk/src/ois/OISForceFeedback.cpp	(revision 5695)
@@ -27,16 +27,48 @@
 
 //-------------------------------------------------------------//
-void ForceFeedback::_addEffectTypes( Effect::EForce force, Effect::EType type )
+ForceFeedback::ForceFeedback() : mSetGainSupport(false), mSetAutoCenterSupport(false)
 {
-	if( force == Effect::UnknownForce || type == Effect::Unknown )
-		OIS_EXCEPT( E_General, "Unknown Force||Type was added too effect list..." );
-
-	mSupportedEffects[force] = type;
 }
 
 //-------------------------------------------------------------//
-const ForceFeedback::SupportedEffectList& 
-						ForceFeedback::getSupportedEffects() const
+void ForceFeedback::_addEffectTypes( Effect::EForce force, Effect::EType type )
+{
+	if( force <= Effect::UnknownForce || force >= Effect::_ForcesNumber
+		|| type <= Effect::Unknown || type >= Effect::_TypesNumber )
+		OIS_EXCEPT( E_General, "Can't add unknown effect Force/Type to the supported list" );
+
+	mSupportedEffects.insert(std::pair<Effect::EForce, Effect::EType>(force, type));
+}
+
+//-------------------------------------------------------------//
+void ForceFeedback::_setGainSupport( bool on )
+{
+	mSetGainSupport = on;
+}
+
+//-------------------------------------------------------------//
+void ForceFeedback::_setAutoCenterSupport( bool on )
+{
+	mSetAutoCenterSupport = on;
+}
+
+//-------------------------------------------------------------//
+const ForceFeedback::SupportedEffectList& ForceFeedback::getSupportedEffects() const
 {
 	return mSupportedEffects;
 }
+
+//-------------------------------------------------------------//
+bool ForceFeedback::supportsEffect(Effect::EForce force, Effect::EType type) const
+{
+    const std::pair<SupportedEffectList::const_iterator, SupportedEffectList::const_iterator> 
+	    iterRange = mSupportedEffects.equal_range(force);
+	SupportedEffectList::const_iterator iter;
+	for (iter = iterRange.first; iter != iterRange.second; iter++)
+	{
+	  if ((*iter).second == type)
+		return true;
+	}
+
+	return false;
+}
Index: code/trunk/src/ois/OISForceFeedback.h
===================================================================
--- code/trunk/src/ois/OISForceFeedback.h	(revision 5693)
+++ code/trunk/src/ois/OISForceFeedback.h	(revision 5695)
@@ -36,5 +36,5 @@
 	{
 	public:
-		ForceFeedback() {}
+		ForceFeedback();
 		virtual ~ForceFeedback() {}
 
@@ -44,4 +44,5 @@
 			Individual effects have gain levels; however, this affects all
 			effects at once.
+			Note: If the device does not support master gain setting, nothing is done
 		@param level
 			A value between 0.0 and 1.0 represent the percentage of gain. 1.0
@@ -56,4 +57,5 @@
 			the joystick back to center. DirectInput only has an on/off setting,
 			whereas linux has levels.. Though, we go with DI's on/off mode only
+			Note: If the device does not support auto-centering, nothing is done
 		@param auto_on
 			true to turn auto centering on, false to turn off.
@@ -87,5 +89,11 @@
         virtual short getFFAxesNumber() = 0;
 
-		typedef std::map<Effect::EForce, Effect::EType> SupportedEffectList;
+		/**
+		@remarks
+			Get the current load (%, in [0, 100] of the FF device memory 
+		*/
+		virtual unsigned short getFFMemoryLoad() = 0;
+
+		typedef std::multimap<Effect::EForce, Effect::EType> SupportedEffectList;
 		/**
 		@remarks
@@ -94,8 +102,18 @@
 		const SupportedEffectList& getSupportedEffects() const;
 
+		/**
+		@remarks
+			Tell if a given force / effect type pair is supported
+		*/
+		bool supportsEffect(Effect::EForce force, Effect::EType type) const;
+
 		void _addEffectTypes( Effect::EForce force, Effect::EType type );
+		void _setGainSupport( bool on );
+		void _setAutoCenterSupport( bool on );
 
 	protected:
 		SupportedEffectList mSupportedEffects;
+		bool mSetGainSupport;
+		bool mSetAutoCenterSupport;
 	};
 }
Index: code/trunk/src/ois/OISJoyStick.h
===================================================================
--- code/trunk/src/ois/OISJoyStick.h	(revision 5693)
+++ code/trunk/src/ois/OISJoyStick.h	(revision 5695)
@@ -32,5 +32,5 @@
 
 	//! POV / HAT Joystick component
-	class _OISExport Pov : Component
+	class _OISExport Pov : public Component
 	{
 	public:
@@ -51,5 +51,5 @@
 
 	//! A sliding axis - only used in Win32 Right Now
-	class _OISExport Slider : Component
+	class _OISExport Slider : public Component
 	{
 	public:
Index: code/trunk/src/ois/OISPrereqs.h
===================================================================
--- code/trunk/src/ois/OISPrereqs.h	(revision 5693)
+++ code/trunk/src/ois/OISPrereqs.h	(revision 5695)
@@ -167,6 +167,6 @@
 	{
 	public:
-		Button() {}
-		Button(bool bPushed) : Component(OIS_Button), pushed(bPushed) {};
+		Button() : Component(OIS_Button), pushed(false) {}
+		Button(bool bPushed) : Component(OIS_Button), pushed(bPushed) {}
 		//! true if pushed, false otherwise
 		bool pushed;
Index: code/trunk/src/ois/linux/EventHelpers.cpp
===================================================================
--- code/trunk/src/ois/linux/EventHelpers.cpp	(revision 5693)
+++ code/trunk/src/ois/linux/EventHelpers.cpp	(revision 5695)
@@ -34,7 +34,21 @@
 #ifdef OIS_LINUX_JOY_DEBUG
 # include <iostream>
-  using namespace std;
-#endif
-
+#endif
+
+// Fixes for missing macros in input.h
+#ifndef FF_EFFECT_MIN
+#define FF_EFFECT_MIN FF_RUMBLE
+#endif
+#ifndef FF_EFFECT_MAX
+#define FF_EFFECT_MAX FF_RAMP
+#endif
+#ifndef FF_WAVEFORM_MIN
+#define FF_WAVEFORM_MIN FF_SQUARE
+#endif
+#ifndef FF_WAVEFORM_MAX
+#define FF_WAVEFORM_MAX FF_CUSTOM
+#endif
+
+using namespace std;
 using namespace OIS;
 
@@ -42,33 +56,49 @@
 {
 public:
-	std::vector<int> buttons, relAxes, absAxes, hats;
+	vector<int> buttons, relAxes, absAxes, hats;
 };
 
-bool inline isBitSet(unsigned long bits[], unsigned int bit)
-{
-	return (bits[bit/(sizeof(long)*8)] >> ((bit)%(sizeof(long)*8))) & 1;
-}
+bool inline isBitSet(unsigned char bits[], unsigned int bit)
+{
+  return (bits[(bit)/(sizeof(unsigned char)*8)] >> ((bit)%(sizeof(unsigned char)*8))) & 1;
+}
+
 //-----------------------------------------------------------------------------//
 DeviceComponentInfo getComponentInfo( int deviceID )
 {
-	unsigned long info[2][((KEY_MAX-1)/(sizeof(long)*8)) +1];
-	memset( info, 0, sizeof(info) );
+	unsigned char ev_bits[1 + EV_MAX/8/sizeof(unsigned char)];
+	memset( ev_bits, 0, sizeof(ev_bits) );
+
+	//Read "all" (hence 0) components of the device
+#ifdef OIS_LINUX_JOY_DEBUG
+	cout << "EventUtils::getComponentInfo(" << deviceID 
+		 << ") : Reading device events features" << endl;
+#endif
+	if (ioctl(deviceID, EVIOCGBIT(0, sizeof(ev_bits)), ev_bits) == -1)
+		OIS_EXCEPT( E_General, "Could not read device events features");
 
 	DeviceComponentInfo components;
-
-	//Read "all" (hence 0) components of the device - read into first entry
-	ioctl(deviceID, EVIOCGBIT(0, EV_MAX), info[0]);
 
 	for (int i = 0; i < EV_MAX; i++)
 	{
-		if( isBitSet(info[0], i) )
+		if( isBitSet(ev_bits, i) )
 		{
-			memset( info[1], 0, sizeof(info) / 2 );
-			ioctl(deviceID, EVIOCGBIT(i, KEY_MAX), info[1]);
-			for (int j = 0; j < KEY_MAX; j++)
+		    // Absolute axis.
+		    if(i == EV_ABS)
 			{
-				if( isBitSet(info[1], j) )
+			    unsigned char abs_bits[1 + ABS_MAX/8/sizeof(unsigned char)];
+			    memset( abs_bits, 0, sizeof(abs_bits) );
+
+#ifdef OIS_LINUX_JOY_DEBUG
+				cout << "EventUtils::getComponentInfo(" << deviceID 
+					 << ") : Reading device absolute axis features" << endl;
+#endif
+
+				if (ioctl(deviceID, EVIOCGBIT(i, sizeof(abs_bits)), abs_bits) == -1)
+				    OIS_EXCEPT( E_General, "Could not read device absolute axis features");
+
+				for (int j = 0; j < ABS_MAX; j++)
 				{
-					if(i == EV_ABS)
+				    if( isBitSet(abs_bits, j) )
 					{
 						//input_absinfo abInfo;
@@ -89,11 +119,45 @@
 						}
 					}
-					else if(i == EV_REL)
+				}
+			}
+			else if(i == EV_REL)
+			{
+			    unsigned char rel_bits[1 + REL_MAX/8/sizeof(unsigned char)];
+				memset( rel_bits, 0, sizeof(rel_bits) );
+				
+#ifdef OIS_LINUX_JOY_DEBUG
+				cout << "EventUtils::getComponentInfo(" << deviceID 
+					 << ") : Reading device relative axis features" << endl;
+#endif
+
+				if (ioctl(deviceID, EVIOCGBIT(i, sizeof(rel_bits)), rel_bits) == -1)
+				    OIS_EXCEPT( E_General, "Could not read device relative axis features");
+				
+				for (int j = 0; j < REL_MAX; j++)
+				{
+				    if( isBitSet(rel_bits, j) )
 					{
-						components.relAxes.push_back(j);
+					    components.relAxes.push_back(j);
 					}
-					else if(i == EV_KEY)
+				}
+			}
+			else if(i == EV_KEY)
+			{
+			    unsigned char key_bits[1 + KEY_MAX/8/sizeof(unsigned char)];
+				memset( key_bits, 0, sizeof(key_bits) );
+				
+#ifdef OIS_LINUX_JOY_DEBUG
+				cout << "EventUtils::getComponentInfo(" << deviceID 
+					 << ") : Reading device buttons features" << endl;
+#endif
+
+				if (ioctl(deviceID, EVIOCGBIT(i, sizeof(key_bits)), key_bits) == -1)
+				    OIS_EXCEPT( E_General, "Could not read device buttons features");
+				
+				for (int j = 0; j < KEY_MAX; j++)
+				{
+				    if( isBitSet(key_bits, j) )
 					{
-						components.buttons.push_back(j);
+					    components.buttons.push_back(j);
 					}
 				}
@@ -108,5 +172,6 @@
 bool EventUtils::isJoyStick( int deviceID, JoyStickInfo &js )
 {
-	if( deviceID == -1 ) OIS_EXCEPT( E_General, "Error with File Descriptor" );
+	if( deviceID == -1 ) 
+		OIS_EXCEPT( E_General, "Error with File Descriptor" );
 
 	DeviceComponentInfo info = getComponentInfo( deviceID );
@@ -117,10 +182,12 @@
 
 	#ifdef OIS_LINUX_JOY_DEBUG
-	  cout << "\n\nDisplaying ButtonMapping Status:";
+	cout << endl << "Displaying ButtonMapping Status:" << endl;
 	#endif
-	for(std::vector<int>::iterator i = info.buttons.begin(), e = info.buttons.end(); i != e; ++i )
+	for(vector<int>::iterator i = info.buttons.begin(), e = info.buttons.end(); i != e; ++i )
 	{
 		//Check to ensure we find at least one joy only button
-		if( (*i >= BTN_JOYSTICK && *i <= BTN_THUMBR) || (*i >= BTN_WHEEL && *i <= BTN_GEAR_UP ) )
+		if( (*i >= BTN_JOYSTICK && *i < BTN_GAMEPAD)  
+			|| (*i >= BTN_GAMEPAD && *i < BTN_DIGI)
+			|| (*i >= BTN_WHEEL && *i < KEY_OK) )
 			joyButtonFound = true;
 
@@ -128,7 +195,11 @@
 
 		#ifdef OIS_LINUX_JOY_DEBUG
-		  cout << "\nButton Mapping ID (hex): " << hex << *i << " OIS Button Num: " << dec << (buttons-1);
+		  cout << "Button Mapping ID (hex): " << hex << *i 
+			   << " OIS Button Num: " << dec << buttons-1 << endl;
 		#endif
 	}
+	#ifdef OIS_LINUX_JOY_DEBUG
+	cout << endl;
+	#endif
 
 	//Joy Buttons found, so it must be a joystick or pad
@@ -140,20 +211,32 @@
 		js.axes = info.relAxes.size() + info.absAxes.size();
 		js.hats = info.hats.size();
+		#ifdef OIS_LINUX_JOY_DEBUG
+		  cout << endl << "Device name:" << js.vendor << endl;
+		  cout << "Device unique Id:" << getUniqueId(deviceID) << endl;
+		  cout << "Device physical location:" << getPhysicalLocation(deviceID) << endl;
+		#endif
 
 		//Map the Axes
 		#ifdef OIS_LINUX_JOY_DEBUG
-		  cout << "\n\nDisplaying AxisMapping Status:";
+		  cout << endl << "Displaying AxisMapping Status:" << endl;
 		#endif
 		int axes = 0;
-		for(std::vector<int>::iterator i = info.absAxes.begin(), e = info.absAxes.end(); i != e; ++i )
+		for(vector<int>::iterator i = info.absAxes.begin(), e = info.absAxes.end(); i != e; ++i )
 		{
 			js.axis_map[*i] = axes;
 
+#ifdef OIS_LINUX_JOY_DEBUG
+			cout << "EventUtils::isJoyStick(" << deviceID 
+					  << ") : Reading device absolute axis #" << *i << " features" << endl;
+#endif
+
 			input_absinfo absinfo;
-			ioctl(deviceID, EVIOCGABS(*i), &absinfo);
+			if (ioctl(deviceID, EVIOCGABS(*i), &absinfo) == -1)
+				OIS_EXCEPT( E_General, "Could not read device absolute axis features");
 			js.axis_range[axes] = Range(absinfo.minimum, absinfo.maximum);
 
 			#ifdef OIS_LINUX_JOY_DEBUG
-			  cout << "\nAxis Mapping ID (hex): " << hex << *i << " OIS Axis Num: " << dec << axes;
+			  cout << "Axis Mapping ID (hex): " << hex << *i 
+				   << " OIS Axis Num: " << dec << axes << endl;
 			#endif
 
@@ -166,9 +249,45 @@
 
 //-----------------------------------------------------------------------------//
-std::string EventUtils::getName( int deviceID )
-{
+string EventUtils::getName( int deviceID )
+{
+#ifdef OIS_LINUX_JOY_DEBUG
+	cout << "EventUtils::getName(" << deviceID 
+		 << ") : Reading device name" << endl;
+#endif
+
 	char name[OIS_DEVICE_NAME];
-	ioctl(deviceID, EVIOCGNAME(OIS_DEVICE_NAME), name);
-	return std::string(name);
+	if (ioctl(deviceID, EVIOCGNAME(OIS_DEVICE_NAME), name) == -1)
+		OIS_EXCEPT( E_General, "Could not read device name");
+	return string(name);
+}
+
+//-----------------------------------------------------------------------------//
+string EventUtils::getUniqueId( int deviceID )
+{
+#ifdef OIS_LINUX_JOY_DEBUG
+	cout << "EventUtils::getUniqueId(" << deviceID 
+		 << ") : Reading device unique Id" << endl;
+#endif
+
+#define OIS_DEVICE_UNIQUE_ID 128
+	char uId[OIS_DEVICE_UNIQUE_ID];
+	if (ioctl(deviceID, EVIOCGUNIQ(OIS_DEVICE_UNIQUE_ID), uId) == -1)
+		OIS_EXCEPT( E_General, "Could not read device unique Id");
+	return string(uId);
+}
+
+//-----------------------------------------------------------------------------//
+string EventUtils::getPhysicalLocation( int deviceID )
+{
+#ifdef OIS_LINUX_JOY_DEBUG
+	cout << "EventUtils::getPhysicalLocation(" << deviceID 
+		 << ") : Reading device physical location" << endl;
+#endif
+
+#define OIS_DEVICE_PHYSICAL_LOCATION 128
+	char physLoc[OIS_DEVICE_PHYSICAL_LOCATION];
+	if (ioctl(deviceID, EVIOCGPHYS(OIS_DEVICE_PHYSICAL_LOCATION), physLoc) == -1)
+		OIS_EXCEPT( E_General, "Could not read device physical location");
+	return string(physLoc);
 }
 
@@ -177,5 +296,5 @@
 {
 	//Linux Event to OIS Event Mappings
-	std::map<int, Effect::EType> typeMap;
+	map<int, Effect::EType> typeMap;
 	typeMap[FF_CONSTANT] = Effect::Constant;
 	typeMap[FF_RAMP]     = Effect::Ramp;
@@ -191,41 +310,71 @@
 	typeMap[FF_CUSTOM]   = Effect::Custom;
 
-	std::map<int, Effect::EForce> forceMap;
+	map<int, Effect::EForce> forceMap;
 	forceMap[FF_CONSTANT] = Effect::ConstantForce;
-	forceMap[FF_RAMP] = Effect::RampForce;
-	forceMap[FF_PERIODIC] = Effect::PeriodicForce;
-	forceMap[FF_CUSTOM] = Effect::CustomForce;
+	forceMap[FF_RAMP]     = Effect::RampForce;
+	forceMap[FF_SPRING]   = Effect::ConditionalForce;
+	forceMap[FF_FRICTION] = Effect::ConditionalForce;
+	forceMap[FF_SQUARE]   = Effect::PeriodicForce;
+	forceMap[FF_TRIANGLE] = Effect::PeriodicForce;
+	forceMap[FF_SINE]     = Effect::PeriodicForce;
+	forceMap[FF_SAW_UP]   = Effect::PeriodicForce;
+	forceMap[FF_SAW_DOWN] = Effect::PeriodicForce;
+	forceMap[FF_DAMPER]   = Effect::ConditionalForce;
+	forceMap[FF_INERTIA]  = Effect::ConditionalForce;
+	forceMap[FF_CUSTOM]   = Effect::CustomForce;
 
 	//Remove any previously existing memory and create fresh
 	removeForceFeedback( ff );
-	*ff = new LinuxForceFeedback();
-
-	unsigned long info[4] = {0,0,0,0};
-	unsigned long subinfo[4]= {0,0,0,0};
-
-	//Read overall force feedback components of the device
-	ioctl(deviceID, EVIOCGBIT(EV_FF, sizeof(long)*4), info);
+	*ff = new LinuxForceFeedback(deviceID);
+
+	//Read overall force feedback features
+	unsigned char ff_bits[1 + FF_MAX/8/sizeof(unsigned char)];
+	memset(ff_bits, 0, sizeof(ff_bits));
+
+#ifdef OIS_LINUX_JOY_DEBUG
+	cout << "EventUtils::enumerateForceFeedback(" << deviceID 
+		 << ") : Reading device force feedback features" << endl;
+#endif
+
+	if (ioctl(deviceID, EVIOCGBIT(EV_FF, sizeof(ff_bits)), ff_bits) == -1)
+		OIS_EXCEPT( E_General, "Could not read device force feedback features");
+
+
+    #ifdef OIS_LINUX_JOY_DEBUG
+	cout << "FF bits: " << hex;
+	for (int i = 0; i < sizeof(ff_bits); i++)
+		cout << (int)ff_bits[i];
+	cout << endl << dec;
+    #endif
 
 	//FF Axes
-	//if( isBitSet(info, ABS_X) ) //X Axis
-	//if( isBitSet(info, ABS_Y) ) //Y Axis
-	//if( isBitSet(info, ABS_WHEEL) ) //Wheel
+	//if( isBitSet(ff_bits, ABS_X) ) //X Axis
+	//if( isBitSet(ff_bits, ABS_Y) ) //Y Axis
+	//if( isBitSet(ff_bits, ABS_WHEEL) ) //Wheel
 
 	//FF Effects
-	for( int effect = ABS_WHEEL+1; effect < FF_MAX; effect++ )
+	for( int effect = FF_EFFECT_MIN; effect <= FF_WAVEFORM_MAX; effect++ )
 	{
-		if(isBitSet(info, effect))
+		// The RUMBLE force type is ignored, as periodic force one is more powerfull.
+		// The PERIODIC force type is processed later, for each associated periodic effect type.
+		if (effect == FF_RUMBLE || effect == FF_PERIODIC)
+			continue;
+
+		if(isBitSet(ff_bits, effect))
 		{
-			//std::cout << "\tEffect Type: " << effect << std::endl;
-			memset(subinfo, 0, sizeof(subinfo));
-			//Read any info about this supported effect
-			ioctl(deviceID, EVIOCGBIT(effect, sizeof(long)*4), subinfo);
-			for( int force = 0; force < FF_MAX; force++ )
-			{
-				if(isBitSet(subinfo, force))
-					(*ff)->_addEffectTypes( forceMap[force], typeMap[effect] );
-			}
+			#ifdef OIS_LINUX_JOY_DEBUG
+		    cout << "  Effect Type: " << Effect::getEffectTypeName(typeMap[effect]) << endl;
+			#endif
+
+			(*ff)->_addEffectTypes( forceMap[effect], typeMap[effect] );
 		}
 	}
+
+	//FF device properties
+	if (isBitSet(ff_bits, FF_GAIN))
+		(*ff)->_setGainSupport(true);
+		
+	if (isBitSet(ff_bits, FF_AUTOCENTER))
+		(*ff)->_setAutoCenterSupport(true);
 
 	//Check to see if any effects were added, else destroy the pointer
Index: code/trunk/src/ois/linux/EventHelpers.h
===================================================================
--- code/trunk/src/ois/linux/EventHelpers.h	(revision 5693)
+++ code/trunk/src/ois/linux/EventHelpers.h	(revision 5695)
@@ -43,4 +43,6 @@
 
 		static std::string getName( int deviceID );
+		static std::string getUniqueId( int deviceID );
+		static std::string getPhysicalLocation( int deviceID );
 	};
 }
